'use strict';
const WpaCli = require('./');
const exec = require('child_process').exec;
var wpa = new WpaCli('p2p0');
wpa.on('ready', function() {
    console.log('ready');
    wpa.listInterfaces(function(interfaceDetails) {

        var interfaces = Object.keys(interfaceDetails);

        interfaces.forEach(function(iface) {

            if (/\w{1,20}\-\w{1,20}\-\w{1,20}/.test(iface)) {
                wpa.removeVitualInterface(iface, function(err) {
                    console.log('done remove', iface, err);
                });
            }
        });
    });
    wpa.on('peer_found', function(peer) {
        console.log('peer found:', peer);
        wpa.once('peer_connected', function(peerInterface) {
            console.log('connected', peerInterface);
            exec('ifconfig ' + peerInterface + ' 192.168.2.1 up', function(err, stdout, stderr) {
                console.log('interface ip assigned', err, stdout, stderr);
                if (!err) {
                    var dhcpConf = '# Sample udhcpd configuration file (/etc/udhcpd.conf)\n# The start and end of the IP lease block\nstart           192.168.2.20    #default: 192.168.0.20\nend             192.168.2.254   #default: 192.168.0.254\n# The interface that udhcpd will use\ninterface       ' + peerInterface + '             #default: eth0\n#Examles\nopt     dns     8.8.8.8  8.8.4.4 # public google dns servers\noption  subnet  255.255.255.0\nopt     router  192.168.2.1\noption  lease   864000          # 10 days of\n';
                    exec('echo "' + dhcpConf + '" > /etc/udhcpd.conf && udhcpd /etc/udhcpd.conf', function functionName(err, stdout, stderr) {
                        if (!err) {
                            console.log('dhcp started:', err, stdout, stderr);
                        }
                    });
                }
            });
        });
        wpa.once('peer_invitation_recieved', function(deviceAddress) {
            console.log('invite recieved', deviceAddress);
            wpa.peerConnectPBC(deviceAddress, false);
        });
    }).on('peer_disconnected', function(peer) {
        console.log(peer, 'disconnected');
    }).peerFind();

    // wpa.listNetworks(  )
    // wpa.addNetwork()
    // wpa.setSSID(0, 'ssid')
    // wpa.setPassword(0, 'password')
    // wpa.enableNetwork(0)
    // wpa.selectNetwork(0)
});

wpa.connect();

wpa.on('status', function(status) {
    console.log(status);
});
wpa.on('scan_results', function(scanResults) {
    console.log(scanResults);
});
wpa.on('list_network', function(networks) {
    console.log(networks);
});
// wpa.on('raw_msg', function(msg) {
//     console.log(msg);
// });
wpa.on('peer_found', function(peer) {
    console.log('peer found:', peer);
});
